/***************************************************************************/
/*                                                                         */
/*                              KISS Types                                 */
/*                                                                         */
/*                                                                         */
/***************************************************************************/

#ifndef __FILEHDRTYPES_H
#define __FILEHDRTYPES_H

#include "KISSTypes.h"

#define KISS_ID 0x5353694b
#define KISS_CEL_MARK 0x20
#define KISS_PAL_MARK 0x10
#define KISS_C32_MARK 0x21

#define PAL_MAX_COLOURS 256

#define KISS_MAX_PALGRP 10

#define CELHDRRESERVED 16

typedef struct __celhdrblock { int       kissdataid;
                               BYTE      mark;
                               BYTE      bpp;
                               short int reserved1;
                               short int width;
                               short int height;
                               short int x_offset;
                               short int y_offset;
                               BYTE      reserved2[CELHDRRESERVED];
                             } KISS_CEL_HEADER;

typedef struct __oldcel { short int width;
                          short int height; } KISS_OLD_CEL_HEADER;

#define PALHDRRESERVED 20

typedef struct __palhdrblock { int       kissdataid;
                               BYTE      mark;
                               BYTE      bpcol;
                               short int reserved1;
                               short int colspergrp;
                               short int numgroup;
                               BYTE      reserved2[PALHDRRESERVED];
                             } KISS_PAL_HEADER;

/***************************************************************************/

typedef struct __ropal {
                         BYTE  fixed13;
                         BYTE  colno;
                         BYTE  fixed10;
                         BYTE  r,g,b; } RISCOS_PALETTE_ENTRY;

/* NB Can't use sizeof, as it rounds to words */

#define BYTESPERCOL 6

#endif
