/***************************************************************************/
/*                                                                         */
/*                                KISS Doll data                           */
/*                                                                         */
/***************************************************************************/

#include <stdlib.h>
#include "BOOL.h"
#include "KISSTypes.h"
#include "FKISSTypes.h"
#include "lzh.h"

/*
 * Switches controlling checking of FKISS (overwritable from command line)
 */

BOOL case_sensitive_fkiss = TRUE;

/*
 * Main KISS data variables.
 */

const int default_border = 0;
const COORD_PAIR default_imagesize = { 448, 320 };

int border_colour = 0;

COORD_PAIR imagesize = { 0, 0 };
COORD_PAIR requestedSize = { 0, 0}; /* The size in the cnf file */

KISS_PALETTE_LIST KISS_palettes=NULL;
KISS_OBJECT_LIST  KISS_objects=NULL;
KISS_CEL_LIST     KISS_cels=NULL;

int KISS_palette_group[MAX_SETS];

int CelCount= 0,
    ObjectCount=0,
    PaletteCount=0,
    ActiveSetsMask = 0;

int MaxFixValue = 0;

BOOL CherryKISS       = FALSE,
     ExtendedPalette  = FALSE;

FKISS_EVENT_LIST fkiss_misc_list      = NULL,
                 fkiss_alarm_list     = NULL,
                 fkiss_mouse_list     = NULL,
                 fkiss_collision_list = NULL,
                 fkiss_label_list     = NULL,
                 fkiss_key_list       = NULL,
                 fkiss_pointer_list   = NULL;

int fkiss_flags = FKISS_K_Initial;

FKISS_VARIABLE_LIST fkiss_variables = NULL;

FKISS_GROUP_LIST fkiss_groups = NULL;

int KISS_Version = 0,
    KISS_ColourModel = 0;

const KISS_RANK_LIMITS_TYPE rankLimits[KISS_V_GS2PLUS] =
   {
     { { 640, 400 },  16, 128, 128 },
     { { 640, 400 }, 256, 256, 256 },
   };

/*
 * Stuff to support lzh extraction
 */

char *lzhArchiveName=NULL;

LZH_CONTENT_LIST lzhArchiveContents=NULL;

BOOL syntax_only = FALSE,
     show_progress = FALSE,
     remove_working_directory = FALSE;

char *working_directory = NULL;
