/********************************************************************************/
/*                                                                              */
/*               FKISS4 key-related utilities for KISS validator                */
/*                                                                              */
/********************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "utilities.h"

/********************************************************************************/

#define NUMALPHA   26
#define NUMDIGIT   10
#define NUMSPECIAL  5

#define DIGIT_BASE   0
#define ALPHA_BASE   (DIGIT_BASE + NUMDIGIT)
#define SPECIAL_BASE (ALPHA_BASE + NUMALPHA)

static char *special_keys[NUMSPECIAL] =
       { "left", "right", "down", "up", "space" };

/********************************************************************************/

static int _keynum(char *s,char **t)
{
  int len,special;

  *t = s;

  for ( special = 0; special < NUMSPECIAL; special++ )
  {
    len = strlen(special_keys[special]);

    if ( struncmp(special_keys[special],s,len) == 0 )
    {
      *t = &(s[len]);
      return special + SPECIAL_BASE;
    }
  }

  if ( isdigit(*s) )
  {
    *t = &(s[1]);
    return *s - '0' + DIGIT_BASE;
  }

  if ( isalpha(*s) )
  {
    *t = &(s[1]);
    return tolower(*s) - 'a' + ALPHA_BASE;
  }
  return -1;
}

/********************************************************************************/

int keyhandler_keynum(char *s)
{
  char *t;
  int keynum = _keynum(s,&t);
  return (*t == 0) ? keynum : -1;
}

