/***************************************************************************/
/*                                                                         */
/*                  Handler for FKISS 4 "Pool" values                      */
/*                                                                         */
/***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <stdarg.h>
#include <ctype.h>
#include "assert.h"

#include "utilities.h"

#define MAXKEYLEN 64
#define MAXVALLEN 64

#define POOLVAL_SEP '.'

#define LEGALCHARS "_-"

/***************************************************************************/

BOOL poolio_validateID(char *id,BOOL poolNameOnly)
{
  BOOL failed = FALSE;
  char *seppos = NULL;
  int len;

  if ( !id || !*id )
    return poolNameOnly;

  while ( *id && !failed )
  {
    if ( *id == POOLVAL_SEP )
    {
      if ( !poolNameOnly || seppos )
        failed = TRUE;
      else seppos = id;
    }
    else
      if ( !isalnum(*id) && (strchr(LEGALCHARS,*id) == NULL) )
        failed = TRUE;
    id++;
  }

  if ( failed )
    return FALSE;

  if ( seppos )
  {
   len = strlen(seppos);
    if ( (len < 1) || (len > (MAXKEYLEN+1)) )
      failed = TRUE;
    else
    {
      len = (int)seppos - (int)id;
      if ( len > MAXKEYLEN )
        failed = TRUE;
    }
  }
  else
    if ( strlen(id) > MAXKEYLEN )
      failed = TRUE;

  return !failed;
}

