/***************************************************************************/
/*                                                                         */
/*                         Low-level utilities for validator               */
/*                                                                         */
/***************************************************************************/

#ifndef __READKISS_H
#define __READKISS_H

#include <stdio.h>
#include <setjmp.h>

#include "KISSTypes.h"

#include "BOOL.h"

#define CNF_MEMORY     '='
#define CNF_SCRNSZ     '('
#define CNF_SCRNSZEND  ')'
#define CNF_PALETTE    '%'
#define CNF_BORDER     '['
#define CNF_CEL        '#'
#define CNF_SET        '$'
#define CNF_SET_CONT   ' '
#define CNF_COMMENT    ';'
#define CNF_FKISS      '@'

#define CNF_CELATTR    '%'
#define CNF_CELGROUP   '!'
#define CNF_FRAMEBEGIN ':'

extern int line_count;

/***************************************************************************/

extern void skipspace(char **cptr);

extern FILE *fopen_path(char *fname,char *mode);
extern FILE *fopen_cnf(char *fname,char *mode);

extern BOOL constrain_file_name_length(char *buffer);

extern BOOL read_next_field(char **cptr, char *termset,char *buffer,
                            int maxbufflen,int *charsread);

extern BOOL read_integer(char **cptr,char *termset,int *value);

extern int read_line(FILE *fp,char *buffer,int bufflen,
                              char *comment,int commentlen,
                              int *lineno,char **buffstart);

/***************************************************************************/

typedef BOOL (*old_format_fn)(FILE *fp,void *hdr);

extern BOOL read_header(FILE *fp,void *header,int hdrlen,
                        old_format_fn readold, BOOL *gs2);

extern KISS_OBJECT_LIST get_object_mark(int mark);

extern KISS_CEL_LIST get_cel_descriptor(char *celname);

#endif
